function COR=cor_matrice(s,P,lseg,rseg);
% Syntax: COR=cor_matrice(s,P,lseg)
%      ou COR=cor_matrice(s,P,lseg,rseg)
% Fonction pour le calcul des coefficients d'autocorrelation a partir du signal
%	s - vecteur signal
%	P - nombre des coefficients d'autocorr. - 1 (on calcule r(0)...r(P) )
%	lseg - longeur du segment
%	rseg - recouvrement des segments (optionnel)
% Dans la matrice COR, les vecteurs des coeffs. sont stockes colonne par colonne
% Il y a un fenetrage Hamming, pas de preaccent. 

if(nargin==3),
 rseg=0;
end

M=floor((length(s)-rseg)/(lseg-rseg));	% no. de seg.
ham=hamming(lseg);

%-------------------------------------------------------------------------
COR=zeros(P+1,M);    % init. de la matrice cepst.

pos=1;

for i=1:M,
% --- choix de la fenetre 
 fen=s(pos:pos+lseg-1).*ham;		% hamming
 pos=pos+lseg-rseg;
 
% --- calcul de coeff. autocor.
 r=xcorr(fen);
 r(1:lseg-1)=[];			% supprime la 1ere moitie du vecteur.
 COR(:,i) = r(1:P+1); 

 if(i/50==floor(i/50)),
  disp(i);
 end 			% indique l'avancement du calcul
 
end	% for i 
