function pfr=false_rej (llr, thr);
%
% Syntax: pfr=false_rej (llr, thr);
%
% Computes false rejection probabililty with a vector of log likelihood 
% ratios and a vector of thresholds. Assumes that the ideal decision for 
% client to be +1 and for imposter -1.
% llr is the log likelihood vector of CLIENTS

points=length(thr);
Nclient=length(llr);
pfr=zeros (1,points); 
for i=1:points,
  t=thr(i);
  false_rej=length (find (llr < t)) / Nclient;
  pfr(i)=false_rej;
end
