function [beg,endd,lab]=load_phn(name);
%
% Syntax: [beg,endd,lab]=load_phn(name); 
%
% loads file with phonetic transcription
% name - filename incl. extension
% beg  - vector with segment begins
% endd - vector with segment ends (both in same units as used in the file)
% lab  - matrix with labels. 

ff=fopen(name,'r');
beg=[]; endd=[]; lab=[];
while 1,
  [b,cnt]=fscanf(ff, '%ld',1);
  if cnt ~= 1, 
    break 
  end
  e=fscanf(ff, '%ld',1);
  l=fscanf(ff, '%s',1);

  beg=[beg, b]; endd=[endd, e]; lab=str2mat (lab, l);
end
fclose(ff);
