function y=med_filter(x,N);
%
% Syntax: y=med_filter(x,N);
%
% Median filtering of order N. If N is odd, the medians are precise (e.g.,
% no interpolation of two medians). On borders, the filter is shortened.
% x - row or column vector.
% y - row or column vector of same dimensions as x.
% N - order of filter.

y=zeros(size(x));
left=floor(N/2); right=ceil(N/2);
%[left right]
lx=length(x);
for i=1:lx, 
  ll=max(1,i-left);
  rr=min(i+right-1, lx);
  y(i)=median(x(ll:rr));
%  [i ll rr]
%  pause
end
