function plotcart2(dat,xdim,ydim);
% Syntax: plotcart2(dat,xdim,ydim)
%
% Fonction pour representation graphique de la carte Kohonnen pour les vecteurs
% a 2 dimensions. Les vecteurs appartenants aux points de la carte sont stockes
% dans comme les colonnes de dat. L'organisation de dat est suivante:
% [0,0] [0,1] ... [0,xdim-1] [1,0] [1,1] ... [1,xdim-1] ........
%        ......... [ydim-1,xdim-1]

xmin=min(dat(1,:));
xmax=max(dat(1,:));
ymin=min(dat(2,:));
ymax=max(dat(2,:));

axis([xmin xmax ymin ymax]);

plot(xmin,ymin);

hold on;
for i=0:ydim-1,
 plot(dat(1,i*xdim+1:(i+1)*xdim),dat(2,i*xdim+1:(i+1)*xdim));
% pause;
end

pause

for i=0:xdim-1,
 plot(dat(1,i+1:xdim:xdim*ydim),dat(2,i+1:xdim:xdim*ydim));
% pause;
end
hold off;
