function R=r_matrice(s,P,lseg,rseg);
% Syntax: R=r_matrice(s,P,lseg)
%      ou R=r_matrice(s,P,lseg,rseg)
% Fonction pour le calcul des coefficients d'autocor. a partir du signal
%	s - vecteur signal
%	P - ordre LPC, la longueur des vecteurs autoco sera P+1
%	lseg - longeur du segment
%	rseg - recouvrement des segments (optionnel)
% Dans la matrice R, les vecteurs sont stockes colonne par colonne
% Il y a un fenetrage Hamming, pas de preaccent

if(nargin==3),
 rseg=0;
end

M=floor((length(s)-rseg)/(lseg-rseg));	% no. de seg.
ham=hamming(lseg);

%-------------------------------------------------------------------------
R=zeros(P+1,M);    % init. de la matrice cepst.

pos=1;

for i=1:M,
% --- choix de la fenetre 
 fen=s(pos:pos+lseg-1).*ham;		% hamming
 pos=pos+lseg-rseg;
 
% --- calcul de coeff. LPC 
 r=xcorr(fen);
 r(1:lseg-1)=[];			% supprime la 1ere moitie du vecteur.
 R(1:P+1, i)=r(1:P+1);

 if(i/50==floor(i/50)),
  disp(i);
 end 			% indique l'avancement du calcul
 
end	% for i 
