function [a,etiquete]=readcod(fichier,xdim,ydim);
% Syntax: [a,etiquete]=readcod(fichier,xdim,ydim)
%                ^ arbitraire 
%
% Fonction pour lire la matrice des vecteurs code d'un fichier de type *.cod
% cree par les programmes de SOM_PAK
% la matrice a va contenir les vecteurs code dans les colonnes,
% la carte de Kohonnen est stockee ligne par ligne
% [0,0] [0,1] ... [0,xdim-1] [1,0] [1,1] ... [1,xdim-1] ........
%        ......... [ydim-1,xdim-1]
% si la lecture des etiquetes est demandee, celles-ci seront stockees dens le 
% vecteur-ligne etiquete avec la longeur egale au nombre des vecteurs 
% (colonnes de a)  

cod=fopen(fichier,'r');
line=fgetl(cod);

N=sscanf(line,'%d',[1 1]);	% dimension des vecteurs 
				% le reste de la ligne => a la poubelle !
if nargout==2,
 etiquete=zeros(1,xdim*ydim);
end 

for i=1:xdim*ydim,
 line=fgetl(cod);		% lit une ligne - vecteur + peut-etre l'etiq.
 ahelp=sscanf(line,'%f');
  
 a(:,i)=ahelp(1:N);
 if nargout==2,
  if length(ahelp)>N,
   etiquete(i)=ahelp(N+1);
  end  				% if et. existe
 end  				% if on veut les et.
end				% du cycle 

fclose(cod); 
