function saveHNM(time,pitch,nb_harm,gain,ki,amp,phase,ceps,fich, ll);

% saveHNM Sauvegarde les parametres de l'analyse HNM dans un fichier
%         au 'float'at HNM. Le nom de fichier doit etre specifie sans
%         l'extension '_hnma'. ATTENTION saveHNM ne cree pas le fichier
%         descripteur ni le fichier des marqueurs.
%	  'float' : 'float', 'double'.
% Exemple : saveHNM(time,pitch,nb_harm,gain,ki,amp,phase,ceps,'fich', 'float');

% Auteur : Olivier Cappe, 29/12/94 - 29/12/94
% (c) TELECOM Paris, departement SIGNAL

% Nombre de fenetres d'analyse
nb_frames = length(time);
% nb_ki = length(ki(1,:));
% nb_ceps = length(ceps(1,:));

% ecriture du fichier
fid = fopen([fich '_hnma.res'],'wb');
for i=1:nb_frames
  fwrite(fid, time(i), 'float');
  fwrite(fid, pitch(i), 'float');
  fwrite(fid, nb_harm(i), 'float');
  fwrite(fid, gain(i), 'float');
  fwrite(fid, ki(i,:), 'float');
  fwrite(fid, amp(i,1:(nb_harm(i)+1)), 'float');
  fwrite(fid, phase(i,1:(nb_harm(i)+1)), 'float');
  fwrite(fid, ceps(i,:), 'float');
end;

fclose(fid);
