function show_fea(feat,lab_list,transc)
% function show_fea(feat,lab_list,transc)
%
% shows feature matrix (for example loaded from HTK feature file), 
% with some text labels on y axis and with 
% reference transcriptions. 
% feat    - features (matrix)
% lablist - (opt) label list in the format 'number space label'. Can be ''
% transc  - (opt) HTK transcription file (can't work with MLF). Can be ''

% basic thing, wants it black'n'white 
imagesc(feat); [P,N] = size(feat); [P N] 
c = flipud(gray); colormap(c); %colorbar; 

% read and show label list if available. 
if (nargin > 1 & ~isempty(lab_list))
  [num,lab] = textread(lab_list,'%d%s');
else % just make them numeric from 0
  lab = 0:P-1;
end

% put them on axis 
h=gca; set (h,'fontsize',8); %set (h,'fontweight','bold');
set(h,'ytick', (1:P)); set (h,'yticklabel', lab); 

% read and show transcriptions if available
if (nargin > 2 & ~isempty(transc))
  add_labels(transc);
end


