function D=spec_dist_a(a1,a2);
% Syntax: D=spec_dist_a(a1,a2)
%
% Calcule la distortion spectrale en dB defini par
% D=sqrt(1/2pi * integral de -pi a pi (10 log10 A1 - 10 log10 A2)^2 domega)
%    ou A1, A2 sont les spectres de puissance LPC: P(omega)=1/|A(omega)|^2
% pour le calcul, la methode directe (pas de cepstres) est utilisee
% a1, a2 sont les vecteurs avec des coefficients LPC
%   de type a=[1 a(1) a(2) .... a(N)]

A1=abs(freqz(1,a1,256,'whole')).^2;
A2=abs(freqz(1,a2,256,'whole')).^2;

D2=sum((10*log10(A1)-10*log10(A2)).^2)/256;

D=sqrt(D2);
