function writedat(fichier,a,etiq_oui,etiquete)
% Syntax: writedat(fichier,a,etiq_oui,etiquete)
%                                ^ arbitraires
%
% Fonction pour ecrire les vecteurs d'apprentissage dans un fichier de type
% *.dat de SOM_PAK. La premiere ligne va contenir la dimension,
% les autres les vecteurs (qui forment les colonnes de a).
%
% Un vecteur des etiquetes (numeriques seulement) peut etre ajoutee - dans ce 
% cas la, specifiez etiq_oui=1, etiquete doit alors etre un vecteur ligne
% avec la longeur egale au nombre de colonnes de a
% Il est fortement conseille de ne pas utiliser l'etiquete 0, parce que
% dans readcod, 0 veut dire qu'il n'y a pas d'etiquete !

sizea=size(a);
N=sizea(1);
if(nargin==2),
 etiq_oui=0;
 etiquete=[];
end 

dat=fopen(fichier,'w');
fprintf(dat,'%d\n',N);

for i=1:sizea(2),		% stocker la matrice "column-wise"
 fprintf(dat,'%f ',a(:,i));
 if etiq_oui==1,
  fprintf(dat,'%d',etiquete(i));  % etiquete a la fin de la ligne
 end
 fprintf(dat,'\n');
end

fclose(dat);
 
